package phase2;

import java.util.Random;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;


public class Phase2Test {

	//auxiliary methods 
	public static boolean equals(DList list1, DList list2) {
		if (list1==list2) return true;
		
		if (list1.getSize()!=list2.getSize()) return false;
		
		for (int i=0; i<list1.getSize(); i++) {
			String s1=list1.getAt(i);
			String s2=list2.getAt(i);
			try {
				if (s1!=null || s2!=null) {
					if (!s1.equals(s2)) 
						return false;
				}
			} catch (Exception e) {
				return false;
			}
		}
		return true;
	}
	
	
	
	//Objects
	Users tree=new Users();
	DList list=new DList();

	DList remove_successor=new DList();
	DList remove_predecessor=new DList();
	
	Random rn=new Random();
	Users empty=new Users();
	
	@Before
	public void setUp() throws Exception {
		//input tree
		//							isegura
		//			bruiz									pmf
		//	asanz			cdepablo				jorge				sonia
		//																		vsuarez
		
		tree.insertUser(new User("isegura","Isabel Segura",44,"M",3));
		tree.insertUser(new User("bruiz","Belen Ruiz",57,"M",1));
		tree.insertUser(new User("pmf","Paloma Martinez",49,"M",3));
		tree.insertUser(new User("asanz","Ana Sanz",32,"M"));
		tree.insertUser(new User("cdepablo","Cesar De Pablo",39,"H"));
		tree.insertUser(new User("jorge","jorge",55,"H"));
		tree.insertUser(new User("sonia","Sonia Garcia",46,"M"));
		tree.insertUser(new User("vsuarez","Victor Suarez",27,"H"));

	
		list.addLast("asanz");
		list.addLast("bruiz");
		list.addLast("cdepablo");
		list.addLast("isegura");
		list.addLast("jorge");
		list.addLast("pmf");
		list.addLast("sonia");
		list.addLast("vsuarez");


		



	}
	
	@Test
	public void testFind() {
		
		assertEquals("Check find, empty tree.", true, 
				empty.findUser("jsegura")==null);
		
		assertEquals("Check find, non empty tree.", true, 
				tree.findUser("a")==null);
		
		User user=new User("cdepablo","Cesar De Pablo",39,"H");
		
		assertEquals("Check find, tree.", true, 
				tree.findUser("cdepablo").equals(user));
		
	}
	
	@Test
	public void testComplaint() {
		
		
		User u1=tree.findUser("sonia");
		int num1=u1.num_complaints;
		tree.complaint("sonia");
		User u2=tree.findUser("sonia");
		int num2=u2.num_complaints;

		assertEquals("Check complaint < 3.", true, (num1+1)==num2);
		
		for (int i=1; i<=4; i++) {
			tree.complaint("sonia");
		}
		list.removeAll("sonia");

		DList output=tree.getSortedList();
		assertEquals("Check complaint == 5.", true, Phase2Test.equals(output,list));
	}
	
	
	@Test
	public void testInsertUser() {
		Users aux=new Users();
		aux.insertUser(new User("jromo","Juan Romo",18,"H"));
		
		DList newList=new DList();
		newList.addLast("jromo");
		
		assertEquals("Check insert an user in empty tree.", true, 
				Phase2Test.equals(aux.getSortedList(),newList) );		
		
		tree.insertUser(new User("sara","Sara Albacete",15,"M"));
		list.insertAt(6, "sara");
		
//		System.out.println(tree.getSortedList().toString());
//		System.out.println(list.toString());

		assertEquals("Check insert an user in empty tree.", true, 
				Phase2Test.equals(tree.getSortedList(),list) );	
	}



	

	@Test
	public void testRemove() {
	
		tree.removeUser("asanz");
		list.removeAll("asanz");
		
		assertEquals("Check remove a leaf node (nn).", true, 
				Phase2Test.equals(tree.getSortedList(),list) );

		tree.removeUser("bruiz");
		list.removeAll("bruiz");
		
		assertEquals("Check remove a node (rr) with only a child.", true, 
				Phase2Test.equals(tree.getSortedList(),list) );

		tree.removeUser("pmf");
		list.removeAll("pmf");

		assertEquals("Check remove the root (jj) with two children.", true, 
				Phase2Test.equals(tree.getSortedList(),list));

	}

		@Test
	public void testExtremUsers() {
//		System.out.println(tree.getSortedList());
//		tree.showLevel();
		
		DList[] aList=tree.extremUsers();
//		System.out.println("min:"+aList[0].toString());
//		System.out.println("max:"+aList[1].toString());
		DList min=new DList();
		min.addLast("asanz");
		min.addLast("cdepablo");
		min.addLast("jorge");
		min.addLast("sonia");
		min.addLast("vsuarez");

		assertEquals("Check extremeUsers min.", true, 
				Phase2Test.equals(aList[0],min) );

		DList max=new DList();
		max.addLast("isegura");
		max.addLast("pmf");
		assertEquals("Check extremeUsers max.", true, 
				Phase2Test.equals(aList[1],max) );

		
		
	}

	

}
