package phase2;

import java.util.Random;


public class User {
	
	//array with usernames
	public static final String[] USERS={"aa","bb","cc","dd","ee","ff","gg","hh",
		"ii","jj","kk","ll","mm","nn","oo","pp","qq","rr","ss","tt"};
	////array with names
	public static final String[] NAMES={"Alberto","Juan","Ana","Clara",
			"Amalia","Rafael","Carlos","Elisabeth","Javier","Santander"};

	//a method that creates a random user
	public static User createRandomUser() {
		Random rn=new Random();
		int index_user=rn.nextInt(USERS.length);
		int index_name=rn.nextInt(NAMES.length);
		return new User(USERS[index_user],NAMES[index_name],rn.nextInt(100)+1,"N");
}
		
	//OBJECT's attributes
	public String username;
	public String fullname;
	public int age;
	public String gender;
	public int num_complaints;
	
	public User(String username, String fullname, int age, String gender) {
		
			this.username = username;
			this.fullname = fullname;
			this.age = age;
			this.gender = gender;
			this.num_complaints = 0;
	}
		
	public User(String username, String fullname, 
			int age, String gender, int num) {
		
		this.username = username;
		this.fullname = fullname;
		this.age = age;
		this.gender = gender;
		if (num<0) num=0;
		if (num>=5) num=4;
				
		this.num_complaints = num;
}
	public String toString() {
//		return "[username="+username+", fullname="+fullname+", age="+age+", "
//				+ "gender="+gender+", num_complaints="+num_complaints+"]";
		return "[username="+username+", fullname="+fullname+", num_complaints="+num_complaints+"]";
	}
	
	public boolean equals(User obj) {
		boolean result=false;
		if (obj!=null) {
				result=this.username.equalsIgnoreCase(obj.username) && 
				this.fullname.equalsIgnoreCase(obj.fullname) &&
				this.age==obj.age &&
				this.gender.equals(obj.gender) &&
				this.num_complaints==obj.num_complaints;
		}
		return result;
		
	}
}
