package phase3;

import static org.junit.Assert.*;

import java.util.Arrays;

import org.junit.Before;
import org.junit.Test;

import phase1.Request;
import phase1.LstRequest;
public class Phase3Test {
	
	public static boolean equalsArrayOfPairs(Pair[] a1, Pair[]a2) {
		if (a1==null && a2!=null) return false;
		if (a1!=null && a2==null) return false;
		if (a1.length!=a2.length) return false;
		
		for (int i=0; i<a1.length;i++) {
			Pair p1=a1[i];
			Pair p2=a2[i];
			if (!p1.equals(p2)) return false;
		}
		
		return true;
		
	}
	
	
	public static final String cities[]={"Madrid",
"Barcelona", "Valencia","Sevilla","Bilbao",
"Granada","Toledo","Salamanca","Alicante","Caceres"};


	SharingGraph graph=new SharingGraph(cities);
	LstRequest lst=new LstRequest();
	
	Pair[] noConnected=null;
	@Before
	public void setUp() throws Exception {
		lst.addLast(new Request("isegura","Madrid","Barcelona"));
		lst.addLast(new Request("pablo","Sevilla","Madrid"));
		lst.addLast(new Request("lmoreno","Alicante","Madrid"));
		lst.addLast(new Request("pmf","Bilbao","Madrid"));
		lst.addLast(new Request("vsuarez","Granada","Alicante"));
		lst.addLast(new Request("bruiz","Valencia","Madrid"));
		lst.addLast(new Request("sonia","Barcelona","Sevilla"));
		lst.addLast(new Request("joseluis","Madrid","Barcelona"));
		lst.addLast(new Request("harith","Toledo","Granada"));
		lst.addLast(new Request("mateo","Alicante","Barcelona"));
		lst.addLast(new Request("joseluis","Bilbao","Salamanca"));
		lst.addLast(new Request("juan","Toledo","Barcelona"));
		lst.addLast(new Request("israel","Valencia","Barcelona"));
		lst.addLast(new Request("juan","Toledo","Barcelona"));
		lst.addLast(new Request("israel","Valencia","Barcelona"));
		
		graph.setTravels(lst);
		
		
		
		Pair[] noConnected={
				new Pair("Madrid", "Valencia"), 
				new Pair("Madrid", "Bilbao"), 
				new Pair("Madrid", "Granada"), 
				new Pair("Madrid", "Toledo"),
				new Pair("Madrid", "Salamanca"),
				new Pair("Madrid", "Alicante"),
				new Pair("Madrid", "Caceres"),
				
				new Pair("Barcelona", "Valencia"),
				new Pair("Barcelona", "Bilbao"),
				new Pair("Barcelona", "Granada"),
				new Pair("Barcelona", "Toledo"),
				new Pair("Barcelona", "Salamanca"),
				new Pair("Barcelona", "Alicante"),
				new Pair("Barcelona", "Caceres"),

				new Pair("Valencia", "Bilbao"),
				new Pair("Valencia", "Granada"),
				new Pair("Valencia", "Toledo"),
				new Pair("Valencia", "Salamanca"),
				new Pair("Valencia", "Alicante"),
				new Pair("Valencia", "Caceres"),

				
				new Pair("Sevilla", "Valencia"),
				new Pair("Sevilla", "Bilbao"),
				new Pair("Sevilla", "Granada"),
				new Pair("Sevilla", "Toledo"),
				new Pair("Sevilla", "Salamanca"),
				new Pair("Sevilla", "Alicante"),
				new Pair("Sevilla", "Caceres"),

				new Pair("Bilbao", "Valencia"),
				new Pair("Bilbao", "Granada"),
				new Pair("Bilbao", "Toledo"),
				new Pair("Bilbao", "Alicante"),
				new Pair("Bilbao", "Caceres"),

				new Pair("Granada", "Valencia"),
				new Pair("Granada", "Bilbao"),
				new Pair("Granada", "Toledo"),
				new Pair("Granada", "Salamanca"),
				new Pair("Granada", "Caceres"),
				
				
				new Pair("Toledo", "Valencia"),
				new Pair("Toledo", "Bilbao"),
				new Pair("Toledo", "Salamanca"),
				new Pair("Toledo", "Caceres"),
				
				new Pair("Salamanca", "Madrid"),
				new Pair("Salamanca", "Barcelona"),
				new Pair("Salamanca", "Valencia"),
				new Pair("Salamanca", "Sevilla"),
				new Pair("Salamanca", "Bilbao"),
				new Pair("Salamanca", "Granada"),
				new Pair("Salamanca", "Toledo"),
				new Pair("Salamanca", "Alicante"),
				new Pair("Salamanca", "Caceres"),

				
				new Pair("Alicante", "Valencia"),
				new Pair("Alicante", "Bilbao"),
				new Pair("Alicante", "Granada"),
				new Pair("Alicante", "Toledo"),
				new Pair("Alicante", "Salamanca"),
				new Pair("Alicante", "Caceres"),

				new Pair("Caceres", "Madrid"),
				new Pair("Caceres", "Barcelona"),
				new Pair("Caceres", "Valencia"),
				new Pair("Caceres", "Sevilla"),
				new Pair("Caceres", "Bilbao"),
				new Pair("Caceres", "Granada"),
				new Pair("Caceres", "Toledo"),
				new Pair("Caceres", "Salamanca"),
				new Pair("Caceres", "Alicante")};
	
		this.noConnected=noConnected;
	}

	
	@Test
	public void testGetListDestination() {
		String[] from=graph.getListDestination("Salamanca");
		assertEquals("Check testGetListDestination Salamanca (null list).", true, 
				Arrays.equals(from,null));
		
		
		String[] fromMadrid=graph.getListDestination("Alicante");
		Arrays.sort(fromMadrid);
		String []aux={"Barcelona","Madrid"};
		assertEquals("Check testGetListDestination Alicante.", true, 
				Arrays.equals(fromMadrid,aux));
		
	}

	@Test
	public void testGetListOrigin() {

		String[] aToledo=graph.getListOrigin("Toledo");
		assertEquals("Check testgetListOrigin Toledo (null).", true, 
				Arrays.equals(aToledo,null));
		
		
		String[] aTo=graph.getListOrigin("Madrid");
		Arrays.sort(aTo);
		String[] aux={"Alicante","Bilbao","Sevilla","Valencia"};
		assertEquals("Check testgetListOrigin Madrid.", true, 
				Arrays.equals(aTo,aux));
		
		
	}

	@Test
	public void testgetAllCities() {
		String[] depth=graph.getAllCities();
		for (String d:depth) {
			System.out.print(d+",");
		}
		String[] aux={"Madrid","Barcelona","Sevilla",
				"Valencia","Bilbao","Salamanca","Granada"
				,"Alicante","Toledo","Caceres"};
		
		assertEquals("Check getAllCities.", true, Arrays.equals(depth,aux));
	}
	
	@Test
	public void testnoConnected() {
		assertEquals("Check noConnected.", false, 
				equalsArrayOfPairs(graph.nonConnectedCities(),null));
		Pair[] nocon=graph.nonConnectedCities();
		for(Pair p:nocon) {
			System.out.println(p.toString());
		}
		boolean result=equalsArrayOfPairs(nocon,this.noConnected);
		assertEquals("Check noConnected.", true, result);
	}
}
