package phase3;



import java.util.LinkedList;
import java.util.ArrayList;

//java interface for queue

import java.util.Queue;

import phase1.LstRequest;
import phase1.Request;

public class SharingGraph  {
	
	
	
	public String[] cities;
	public int num;
	LinkedList<Adjacent>[] lstAdjacents;
	
		
	public SharingGraph(String[] cities) {
			this.cities=cities;
			this.num=cities.length;
			//we must initialize each adjacent list
			lstAdjacents=new LinkedList[num];
			for (int i=0; i<num; i++) {
				lstAdjacents[i]=new LinkedList<Adjacent>();
			}
	}
	
	public void setTravels(LstRequest lst) {
		if (lst==null) return;
		
		for (int i=0; i<lst.getSize(); i++) {
			Request r=lst.getAt(i);
			int indexO=getIndex(r.origin);
			int indexD=getIndex(r.destination);
			if (indexO!=-1&&indexD!=-1)
				addConnection(indexO,indexD);

		}
	}	
	//searches the city and returns its index
	public int getIndex(String city) {
		int index=-1;
		for (int i=0; i<num && index==-1; i++) {
			if (cities[i].equalsIgnoreCase(city)) 
				index=i;
		}
		return index;
	}
	//checks if index is right and returns its associated city
	public String checkVertex(int index) {
		if (index<0 ||index>=num) {
			System.out.println(index + " wrong!");
			return null;
		}
		return cities[index];
	}
	
	
	
		
	private void addConnection(int i, int j) {
		
		
		boolean contains=false;
		for (int k=0; k<lstAdjacents[i].size() && contains==false;k++) {
			Adjacent obj=lstAdjacents[i].get(k);
			if (obj.vertex==j) {
				contains=true;
				//replace its weight
				obj.w=obj.w+1;
			}
		}
		if (!contains) {
			lstAdjacents[i].add(new Adjacent(j,1));
		}
	}

	//returns all possible
	public String[] getListDestination(String city) {
		int index=getIndex(city);
		if (index==-1) return null;
			
		int sizeList=lstAdjacents[index].size();
		if (sizeList==0) return null;
			
		String result[]=new String[sizeList];
		for (int i=0; i<lstAdjacents[index].size();i++) {
			int adj=lstAdjacents[index].get(i).vertex;
			result[i]=checkVertex(adj);
		}
		return result;
	}
	
	public String[] getListOrigin(String city) {
		int index=getIndex(city);
		String result[]=null;
		if (index!=-1) {
			int sizeList=0;
			
			for (int i=0; i<num;i++) {
				for (int j=0; j<lstAdjacents[i].size();j++) {
					int adj=lstAdjacents[i].get(j).vertex;
					if (index==adj) sizeList++;
				}
			}
			
			if (sizeList==0) return null;
			
			result=new String[sizeList];
			int k=0;
			for (int i=0; i<num;i++) {
				for (int j=0; j<lstAdjacents[i].size();j++) {
					int adj=lstAdjacents[i].get(j).vertex;
					if (index==adj) {
						result[k]=checkVertex(i);
						k++;
					}
				}
			}
			
		}
		return result;
	}
	
	

	
	public int[] getAdjacents(int i) {
		if (checkVertex(i)==null) {
			System.out.println("Nonexistent vertex  " + i);
			return null;
		}
		
		//gets the number of adjacent vertices
		int numAdj=lstAdjacents[i].size();
		//creates the array
		int[] adjVertices=new int[numAdj];
		//saves the adjacent vertices into the array
		for (int j=0; j<numAdj; j++) {
			adjVertices[j]=lstAdjacents[i].get(j).vertex;
		}
		//return the array with the adjacent vertices of i
		return adjVertices;
	}
	
	
	
	
//	public String[] getAllCities() {
//		boolean visited[]=new boolean[num];
//		LinkedList<Integer> path=new LinkedList<Integer>();
//		for (int i=0; i<num;i++) {
//			depth(i,visited,path);
//		}
//		
//		String[] allcities=new String[path.size()];
//		for(Integer i:path) {
//			String city=checkVertex(i);
//			if (city!=null) 
//				allcities[i]=city;
//		//		System.out.print(city+",");
//		}
//		//System.out.println();
//		return allcities;
//	}
//	
	
public String[] getAllCities() {

		ArrayList<String> list_arr = new ArrayList<>();
		
		boolean[] visited = new boolean[num];
		for (int i = 0; i <num; i++) {
			if (!visited[i]) {
				getAllCities(i,visited,list_arr);
			}
			
		}
		if(list_arr.isEmpty()) return null;
		
		String[] result = new String[list_arr.size()];
		result = list_arr.toArray(result);

		return result;
		
	}

	
	
	private void getAllCities(int vertex,boolean[] visited, ArrayList<String> array_list) {
		visited[vertex]=true;
		array_list.add(checkVertex(vertex));
		int[] adjacents=getAdjacents(vertex);
		for (int j = 0; j < adjacents.length; j++) {
			int adj=adjacents[j];
			if (!visited[adj]) {
				getAllCities(adj,visited,array_list);
			}
		}
		
	}

	
	
	

	
	public void show() {
		for (int i=0; i<num; i++) {
			String city=checkVertex(i);
			System.out.print("destinations from: " + city+ "("+i+")");
			if (lstAdjacents[i].size()==0) System.out.println("(empty)");
			else System.out.println();
			for (int j=0; j<lstAdjacents[i].size();j++) {
				Adjacent obj=lstAdjacents[i].get(j);
				String destination=checkVertex(obj.vertex);
				System.out.println("\t"+destination+"("+obj.vertex+") times:"+ obj.w);
			}
		}
	}
	
	
	public Pair[] nonConnectedCities() {
		Pair[] noConnected=null;
		int size=0;
		for (int i=0; i<num; i++) {
			ArrayList<String> lst=noConnectedTo(i);
			size+=lst.size();
		}
		noConnected=new Pair[size];
		
		int j=0;
		for (int i=0; i<num; i++) {
			String origin=checkVertex(i);
			ArrayList<String> lst=noConnectedTo(i);
			if (lst!=null&&lst.size()>0) {
				for(String destination:lst) {
					if (origin!=null & destination!=null) {
						Pair obj=new Pair(origin,destination);
						noConnected[j]=obj;
						j++;
					}
				}

			}
		}
		return noConnected;

	}
	
	public ArrayList<String> noConnectedTo(int index) {
		
		boolean visited[]=new boolean[num];
		ArrayList<String> path=new ArrayList<String>();
		//gets the cities that can be visited from index
		getAllCities(index,visited,path);
		
		ArrayList<String> noConnected=new ArrayList<String>();
		for (int i=0; i<num; i++) {
			if (i!=index) {
				String city=this.checkVertex(i);
				if (!path.contains(city))
					noConnected.add(city);
			}
		}
		
		return noConnected;
		
	}
	
	
	public void breadth() {
		System.out.println("breadth traverse of the graph:");
		
		//to mark when a vertex has already been shown
		boolean visited[]=new boolean[this.cities.length];

		//we have to traverse all vertices
		for (int i=0;i<this.cities.length;i++) {
			if (!visited[i]) { //we only process the non-visited vertex
				breadth(i,visited);
			}
		}
		System.out.println();

	}
	
	

	//breadth order for the vertex i 
	protected void breadth(int i, boolean[] visited) {
		Queue<Integer> q=new LinkedList<Integer>();
		q.add(i);
		while (!q.isEmpty()) {
			int vertex=q.poll();
			String city=this.checkVertex(vertex);
			System.out.print(city+",");
			visited[vertex]=true;
		
			int[] adjacents=getAdjacents(vertex);
			for(int adjVertex:adjacents) {
					//enqueue only those that have not been visited or stored yet 
					if (!visited[adjVertex] && !q.contains(adjVertex)) {
						q.add(adjVertex);
					}
			}
		}
	}
	
	
	public static void main(String args[]) {
		String cities[]={"Madrid",
			"Barcelona", "Valencia","Sevilla","Bilbao",
			"Granada","Toledo","Salamanca","Alicante","Caceres"};
				SharingGraph graph=new SharingGraph(cities);
				LstRequest lst=new LstRequest();
				lst.addLast(new Request(null,"Madrid","Sevilla"));
				lst.addLast(new Request(null,"Madrid","Barcelona"));
				lst.addLast(new Request(null,"Bilbao","Madrid"));
				lst.addLast(new Request(null,"Valencia","Madrid"));
				lst.addLast(new Request(null,"Valencia","Barcelona"));
				lst.addLast(new Request(null,"Madrid","Barcelona"));
				lst.addLast(new Request(null,"Sevilla","Madrid"));
				lst.addLast(new Request(null,"Madrid","Sevilla"));
				lst.addLast(new Request(null,"Alicante","Barcelona"));
				lst.addLast(new Request(null,"Valencia","Madrid"));
				lst.addLast(new Request(null,"Valencia","Barcelona"));
				lst.addLast(new Request(null,"Madrid","Sevilla"));
				lst.addLast(new Request(null,"Madrid","Toledo"));
				lst.addLast(new Request(null,"Toledo","Salamanca"));
				lst.addLast(new Request(null,"Toledo","Salamanca"));
				lst.addLast(new Request(null,"Salamanca","Barcelona"));
				lst.addLast(new Request(null,"Toledo","Caceres"));
				lst.addLast(new Request(null,"Barcelona","Toledo"));
		graph.setTravels(lst);
		String[] allcities=graph.getAllCities();
		for (String city: allcities) {
			System.out.print(city);
		}
		System.out.println();
		
//		String[] fromMadrid=graph.getListDestination("Madrid");
//		if (fromMadrid==null) {
//			System.out.println("There is no travel from Madrid");
//		}
//		Arrays.sort(fromMadrid);
//		for (String city:fromMadrid) {
//			System.out.println(city);
//		}
		//
//		String[] aToBilbao=graph.getListOrigin("Bilbao");
//		Arrays.sort(aToBilbao);
//		for (String city:aToBilbao) {
//			System.out.print(city+",");
//		}
		
//		for (String city:allcities) {
//			System.out.print(city+",");
//		}	
//		
		Pair[] noConnected=graph.nonConnectedCities();
		for(Pair p:noConnected) {
			System.out.println(p.toString());
		}
		
		
	}
	
}
